=== debian/changelog ===
openimageio (1.0.5+dfsg0-1ubuntu1) quantal; urgency=low

  * Build-depend on libtiff-dev rather than libtiff4-dev.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 10 Sep 2012 11:40:17 +0100

openimageio (1.0.5+dfsg0-1build1) quantal; urgency=low

  * Rebuild for libglew1.8.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 03 Sep 2012 14:03:49 +0100

openimageio (1.0.5+dfsg0-1) unstable; urgency=low

  * New upstream release
    + debian/: symbols files added
  * debian/: updated manpages moved to "manpages" sub-dir.
    Thanks to IRIE Shinsuke for the updated manpages (Closes: #673504)
  * debian/patches/: #0002 added to fix FTBFS on Hurd.
    Thanks to Pino Toscano (pino) for the hint

 -- Matteo F. Vescovi <mfv.debian@gmail.com>  Tue, 05 Jun 2012 10:50:52 +0200

openimageio (1.0.3+dfsg0-1) unstable; urgency=low

  * New upstream release
  * debian/patches/:
    + #0001/#0002 (doc generation) merged
      Thanks to David Paleino (dapal) for the hint
  * debian/rules: TBB support disabled
  * debian/: 8 => 9 dh bump

 -- Matteo F. Vescovi <mfv.debian@gmail.com>  Wed, 18 Apr 2012 14:45:11 +0200

openimageio (1.0.0+dfsg0-1) unstable; urgency=low

  * Initial release (Closes: #660984)

 -- Matteo F. Vescovi <mfv.debian@gmail.com>  Sat, 10 Mar 2012 10:39:11 +0100
