=== debian/watch ===
version=3
opts="dversionmangle=s/\+dfsg.*//" \
https://github.com/OpenImageIO/oiio/tags .*/tarball/Release-(.*)
